routes/web.php
<?php

use App\Http\Controllers\HomeController;
use App\Http\Controllers\ProductoController;
use App\Http\Controllers\ProductotiendaController;
use App\Http\Controllers\TiendaController;
use Illuminate\Support\Facades\Route;

// con la uri '/' cargar la accion index del controlador home

// Route::get(
//     '/',  // URI
//     [
//         HomeController::class, // Controlador
//         'index', // accion
//     ]
// )->name('home');

Route::controller(HomeController::class)->group(function () {
    Route::get(
        '/',  // uri
        'index' // accion
    )->name('home');
});

Route::resource('producto', ProductoController::class);
Route::resource('tienda', TiendaController::class);
Route::resource('productotienda', ProductotiendaController::class);

// Route::controller(ProductoController::class)->group(function () {
//     Route::get('/producto', 'index')->name('producto.index');
//     Route::get('/producto/create', 'create')->name('producto.create');
//     Route::post('/producto', 'store')->name('producto.store');
//     Route::get('/producto/edit/{id}', 'edit')->name('producto.edit');
//     Route::get('/producto/{id}', 'show')->name('producto.show');
//     Route::put('/producto/{producto}', 'update')->name('producto.update');
//     Route::delete('/producto/{producto}', 'destroy')->name('producto.destroy');
// });

app/Models/Productotienda.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Support\Facades\Schema;

class Productotienda extends Model
{
    use HasFactory;

    // nombre de la tabla
    protected $table = 'productotiendas';

    // campos asignacion masiva
    protected $fillable = [
        'cantidad',
        'tienda_id',
        'producto_id'
    ];

    public static $labels = [
        'id' => 'Id de la compra',
        'tienda_id' => 'Id de la tienda',
        'producto_id' => 'Id del producto',
        'nombretienda' => 'Nombre de la tienda ',
        'nombreproducto' => 'Nombre del producto',
    ];

    public function tienda(): BelongsTo
    {
        return $this->belongsTo(Tienda::class);
    }

    public function producto(): BelongsTo
    {
        return $this->belongsTo(Producto::class);
    }

    /**
     * Creo una nueva propiedad en el modelo
     * para mostrar el nombre de la tienda
     */

    public function getNombretiendaAttribute()
    {
        return $this->tienda->nombre;
    }

    public function getNombreproductoAttribute()
    {
        return $this->producto->nombre;
    }
    public function getAttributeLabel($attribute)
    {
        return self::$labels[$attribute] ?? $attribute;
    }

    public function getFields()
    {
        return Schema::getColumnListing($this->table);
    }
}

app/Http/Controllers/ProductotiendaController.php
<?php

namespace App\Http\Controllers;

use App\Models\Productotienda;
use Illuminate\Http\Request;
use Illuminate\Support\Arr;

class ProductotiendaController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $productotienda = Productotienda::paginate(9);
        $productotienda->load('tienda', 'producto');
        // dd($productotienda->toArray()['data']);


        return view(
            'productotienda.index',
            compact('productotienda')
        );
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     */
    public function show(Productotienda $productotienda)
    {


        // $productotienda->tienda->nombre; // saco el nombre de la tienda
        // $productotienda->producto->nombre; // saco el nombre del producto

        return view(
            'productotienda.show',
            compact('productotienda')
        );
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Productotienda $productotienda)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Productotienda $productotienda)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Productotienda $productotienda)
    {
        //
    }
}

resources/views/productotienda/index.blade.php
@extends('layouts.main')

@section('titulo', 'Listado de Compras')

@section('cabecera')
    <x-cabecera subtitulo="Listado de Compras">
        <i class="fa-solid fa-cart-shopping"></i> Listado de Compras
    </x-cabecera>

@endsection

@section('contenido')
    @if (session('mensaje'))
        <div class="row m-3">
            <div class="alert alert-info">
                {{ session('mensaje') }}
            </div>
        </div>
    @endif

    <x-listviewrelations :registros="$productotienda" modelo="productotienda" :campos="[
        'cantidad',
        'tienda_id',
        'producto_id',
        'nombretienda',
        'nombreproducto',
        'tienda.nombre',
        'tienda.ubicacion',
        'producto.nombre',
        // [
        //     'label' => 'Nombre de la tienda',
        //     'campo' => 'nombre',
        //     'relacion' => 'tienda',
        // ],
        // [
        //     'label' => 'Nombre del producto',
        //     'valor' => function ($modelo) {
        //         return $modelo->tienda->nombre;
        //     },
        // ],
    ]" />

@endsection

resources/views/productotienda/show.blade.php
@extends('layouts.main')

@section('titulo', 'Mostrar')

@section('cabecera')
    <section class="pt-5 container">
        <div class="row py-lg-5">
            <h1 class="display-4 fw-bold lh-1 mb-3">Ver Compra</h1>
            <p class="col-lg-10 fs-4">
                Estos son los datos de la compra
            </p>
        </div>
    </section>
@endsection

@section('contenido')
    @if (session('mensaje'))
        <div class="row m-2">
            <div class="alert alert-info">
                {{ session('mensaje') }}
            </div>
        </div>
    @endif
    <div class="row mt-3">
        <div class="col">
            <div class="card shadow-xl">
                <div class="card-body">
                    <h5 class="card-title">
                        {{ $productotienda->id }}
                    </h5>
                    <p class="card-text">
                        producto_id: {{ $productotienda->producto_id }}
                    </p>
                    <p class="card-text">
                        Nombre producto: {{ $productotienda->producto->nombre }}
                    </p>

                    <p class="card-text">
                        Tienda_id: {{ $productotienda->tienda_id }}
                    </p>
                    <p class="card-text">
                        Nombre de la tienda: {{ $productotienda->tienda->nombre }}
                    </p>
                    <p class="card-text">
                        Cantidad: {{ $productotienda->cantidad }}
                    </p>


                    <div class="card-footer">
                        <div class="vertical-align-bottom d-flex justify-content-between align-items-center">
                            <a href="{{ route('productotienda.edit', $productotienda) }}" class="btn btn-primary">Editar</a>
                            <form action="{{ route('productotienda.destroy', $productotienda) }}" method="post">
                                @csrf
                                @method('DELETE')
                                <button type="submit" class="btn btn-danger">Eliminar</button>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection